Added options to change compression level for fast, default and best compression levels and added the option to compress in extreme mode for xz.

This commit is contained in:
nhkhai 2020-08-09 16:05:02 +08:00
parent 526ca5ae89
commit 4e90956eb1
2 changed files with 61 additions and 41 deletions

View File

@ -1,9 +1,8 @@
# PiShrink # # PiShrink #
PiShrink is a bash script that automatically shrink a pi image that will then resize to the max size of the SD card on boot. This will make putting the image back onto the SD card faster and the shrunk images will compress better. PiShrink is a bash script that automatically shrink a pi image that will then resize to the max size of the SD card on boot. This will make putting the image back onto the SD card faster and the shrunk images will compress better.
In addition the shrinked image can be compressed with gzip and xz to create an even smaller image. Parallel compression of the image In addition the shrinked image can be compressed with gzip and xz to create an even smaller image. Parallel compression of the image using multiple cores is supported.
using multiple cores is supported.
## Usage ## ## Usage ##
@ -13,8 +12,11 @@ Usage: $0 [-adhrspvzZ] imagefile.img [newimagefile.img]
-s Don't expand filesystem when image is booted the first time -s Don't expand filesystem when image is booted the first time
-v Be verbose -v Be verbose
-r Use advanced filesystem repair option if the normal one fails -r Use advanced filesystem repair option if the normal one fails
-z Compress image after shrinking with gzip -z Compress image after shrinking with gzip (Default is balanced (6) compression)
-Z Compress image after shrinking with xz -Z Compress image after shrinking with xz (Default is balanced (6) compression)
-c Change the compression level from the default, balanced (6) to fast (1 for gzip, 0 or xz)
-C Change the compression level from the default, balanced (6) to best (9)
-e Compress image in extreme mode (Only applicable to xz compression)
-a Compress image in parallel using multiple cores -a Compress image in parallel using multiple cores
-p Remove logs, apt archives, dhcp leases and ssh hostkeys -p Remove logs, apt archives, dhcp leases and ssh hostkeys
-d Write debug messages in a debug log file -d Write debug messages in a debug log file
@ -22,24 +24,27 @@ Usage: $0 [-adhrspvzZ] imagefile.img [newimagefile.img]
If you specify the `newimagefile.img` parameter, the script will make a copy of `imagefile.img` and work off that. You will need enough space to make a full copy of the image to use that option. If you specify the `newimagefile.img` parameter, the script will make a copy of `imagefile.img` and work off that. You will need enough space to make a full copy of the image to use that option.
* `-s` prevents automatic filesystem expantion on the images next boot * `-s` Prevents automatic filesystem expantion on the images next boot.
* `-v` enables more verbose output * `-v` Enables more verbose output.
* `-r` will attempt to repair the filesystem using aditional options if the normal repair fails * `-r` Will attempt to repair the filesystem using aditional options if the normal repair fails.
* `-z` will compress the image after shrinking using gzip. `.gz` extension will be added to the filename. * `-z` Will compress the image after shrinking using gzip. `.gz` extension will be added to the filename.
* `-Z` will compress the image after shrinking using xz. `.xz` extension will be added to the filename. * `-Z` Will compress the image after shrinking using xz. `.xz` extension will be added to the filename.
* `-a` will use option -f9 for pigz and option -T0 for xz and compress in parallel. * `-c Will use option -1 for pigz and option -0 for xz.
* `-d` will create a logfile `pishrink.log` which may help for problem analysis. * `-C Will use option -9.
* `-e Will use option -e for xz.
* `-a` will use option -f for pigz and option -T0 for xz and compress in parallel.
* `-d` will create a logfile `pishrink.log` which may help for problem analysis.
Default options for compressors can be overwritten by defining PISHRINK_GZIP or PSHRINK_XZ environment variables for gzip and xz. Default options for compressors can be overwritten by defining PISHRINK_GZIP or PSHRINK_XZ environment variables for gzip and xz.
## Prerequisites ## ## Prerequisites ##
If you are running PiShrink in VirtualBox you will likely encounter an error if you If you are running PiShrink in VirtualBox you will likely encounter an error if you
attempt to use VirtualBox's "Shared Folder" feature. You can copy the image you wish to attempt to use VirtualBox's "Shared Folder" feature. You can copy the image you wish to
shrink on to the VM from a Shared Folder, but shrinking directctly from the Shared Folder shrink on to the VM from a Shared Folder, but shrinking directctly from the Shared Folder
is know to cause issues. is know to cause issues.
If using Ubuntu, you will likely see an error about `e2fsck` being out of date and `metadata_csum`. The simplest fix for this is to use Ubuntu 16.10 and up, as it will save you a lot of hassle in the long run. If using Ubuntu, you will likely see an error about `e2fsck` being out of date and `metadata_csum`. The simplest fix for this is to use Ubuntu 16.10 and up, as it will save you a lot of hassle in the long run.
## Installation ## ## Installation ##
@ -76,6 +81,6 @@ Shrunk pi.img from 30G to 3.1G
## Contributing ## ## Contributing ##
If you find a bug please create an issue for it. If you would like a new feature added, you can create an issue for it but I can't promise that I will get to it. If you find a bug please create an issue for it. If you would like a new feature added, you can create an issue for it but I can't promise that I will get to it.
Pull requests for new features and bug fixes are more than welcome! Pull requests for new features and bug fixes are more than welcome!

View File

@ -8,9 +8,9 @@ MYNAME="${SCRIPTNAME%.*}"
LOGFILE="${CURRENT_DIR}/${SCRIPTNAME%.*}.log" LOGFILE="${CURRENT_DIR}/${SCRIPTNAME%.*}.log"
REQUIRED_TOOLS="parted losetup tune2fs md5sum e2fsck resize2fs" REQUIRED_TOOLS="parted losetup tune2fs md5sum e2fsck resize2fs"
ZIPTOOLS=("gzip xz") ZIPTOOLS=("gzip xz")
declare -A ZIP_PARALLEL_TOOL=( [gzip]="pigz" [xz]="xz" ) # parallel zip tool to use in parallel mode declare -A ZIP_PARALLEL_TOOL=( [gzip]="pigz" [xz]="xz" ) # Parallel zip tool to use in parallel mode
declare -A ZIP_PARALLEL_OPTIONS=( [gzip]="-f9" [xz]="-T0" ) # options for zip tools in parallel mode declare -A ZIP_PARALLEL_OPTIONS=( [gzip]="-f" [xz]="-T0" ) # Options for zip tools in parallel mode
declare -A ZIPEXTENSIONS=( [gzip]="gz" [xz]="xz" ) # extensions of zipped files declare -A ZIPEXTENSIONS=( [gzip]="gz" [xz]="xz" ) # Extensions of zipped files
function info() { function info() {
echo "$SCRIPTNAME: $1 ..." echo "$SCRIPTNAME: $1 ..."
@ -160,9 +160,12 @@ Usage: $0 [-adhrspvzZ] imagefile.img [newimagefile.img]
-s Don't expand filesystem when image is booted the first time -s Don't expand filesystem when image is booted the first time
-v Be verbose -v Be verbose
-r Use advanced filesystem repair option if the normal one fails -r Use advanced filesystem repair option if the normal one fails
-z Compress image after shrinking with gzip -z Compress image after shrinking with gzip (Default is balanced (6) compression)
-Z Compress image after shrinking with xz -Z Compress image after shrinking with xz (Default is balanced (6) compression)
-a Compress image in parallel using multiple cores -a Compress image in parallel using multiple cores
-c Change the compression level from the default, balanced (6) to fast (1 for gzip, 0 or xz)
-C Change the compression level from the default, balanced (6) to best (9)
-e Compress image in extreme mode (Only applicable to xz compression)
-p Remove logs, apt archives, dhcp leases and ssh hostkeys -p Remove logs, apt archives, dhcp leases and ssh hostkeys
-d Write debug messages in a debug log file -d Write debug messages in a debug log file
EOM EOM
@ -171,17 +174,22 @@ EOM
} }
should_skip_autoexpand=false should_skip_autoexpand=false
compression=6
debug=false debug=false
extreme=false
repair=false repair=false
parallel=false parallel=false
verbose=false verbose=false
prep=false prep=false
ziptool="" ziptool=""
while getopts ":adhprsvzZ" opt; do while getopts ":acCdehprsvzZ" opt; do
case "${opt}" in case "${opt}" in
a) parallel=true;; a) parallel=true;;
c) compression=0;;
C) compression=9;;
d) debug=true;; d) debug=true;;
e) extreme=true;;
h) help;; h) help;;
p) prep=true;; p) prep=true;;
r) repair=true;; r) repair=true;;
@ -194,6 +202,10 @@ while getopts ":adhprsvzZ" opt; do
done done
shift $((OPTIND-1)) shift $((OPTIND-1))
if [ $compression == 0 ] && [[ "$ziptool" == "gzip" ]]; then
compression=1
fi
if [ "$debug" = true ]; then if [ "$debug" = true ]; then
info "Creating log file $LOGFILE" info "Creating log file $LOGFILE"
rm "$LOGFILE" &>/dev/null rm "$LOGFILE" &>/dev/null
@ -203,11 +215,11 @@ fi
echo "${0##*/} $version" echo "${0##*/} $version"
#Args # Args
src="$1" src="$1"
img="$1" img="$1"
#Usage checks # Usage checks
if [[ -z "$img" ]]; then if [[ -z "$img" ]]; then
help help
fi fi
@ -221,7 +233,7 @@ if (( EUID != 0 )); then
exit 3 exit 3
fi fi
# check selected compression tool is supported and installed # Check selected compression tool is supported and installed
if [[ -n $ziptool ]]; then if [[ -n $ziptool ]]; then
if [[ ! " ${ZIPTOOLS[@]} " =~ $ziptool ]]; then if [[ ! " ${ZIPTOOLS[@]} " =~ $ziptool ]]; then
error $LINENO "$ziptool is an unsupported ziptool." error $LINENO "$ziptool is an unsupported ziptool."
@ -235,7 +247,7 @@ if [[ -n $ziptool ]]; then
fi fi
fi fi
#Check that what we need is installed # Check that what we need is installed
for command in $REQUIRED_TOOLS; do for command in $REQUIRED_TOOLS; do
command -v $command >/dev/null 2>&1 command -v $command >/dev/null 2>&1
if (( $? != 0 )); then if (( $? != 0 )); then
@ -244,10 +256,10 @@ for command in $REQUIRED_TOOLS; do
fi fi
done done
#Copy to new file if requested # Copy to new file if requested
if [ -n "$2" ]; then if [ -n "$2" ]; then
f="$2" f="$2"
if [[ -n $ziptool && "${f##*.}" == "${ZIPEXTENSIONS[$ziptool]}" ]]; then # remove zip extension if zip requested because zip tool will complain about extension if [[ -n $ziptool && "${f##*.}" == "${ZIPEXTENSIONS[$ziptool]}" ]]; then # Remove zip extension if zip requested because zip tool will complain about extension
f="${f%.*}" f="${f%.*}"
fi fi
info "Copying $1 to $f..." info "Copying $1 to $f..."
@ -261,10 +273,10 @@ if [ -n "$2" ]; then
img="$f" img="$f"
fi fi
# cleanup at script exit # Cleanup at script exit
trap cleanup EXIT trap cleanup EXIT
#Gather info # Gather info
info "Gathering data" info "Gathering data"
beforesize="$(ls -lh "$img" | cut -d ' ' -f 5)" beforesize="$(ls -lh "$img" | cut -d ' ' -f 5)"
parted_output="$(parted -ms "$img" unit B print)" parted_output="$(parted -ms "$img" unit B print)"
@ -295,7 +307,7 @@ blocksize="$(echo "$tune2fs_output" | grep '^Block size:' | tr -d ' ' | cut -d '
logVariables $LINENO beforesize parted_output partnum partstart parttype tune2fs_output currentsize blocksize logVariables $LINENO beforesize parted_output partnum partstart parttype tune2fs_output currentsize blocksize
#Check if we should make pi expand rootfs on next boot # Check if we should make pi expand rootfs on next boot
if [ "$parttype" == "logical" ]; then if [ "$parttype" == "logical" ]; then
echo "WARNING: PiShrink does not yet support autoexpanding of this type of image" echo "WARNING: PiShrink does not yet support autoexpanding of this type of image"
elif [ "$should_skip_autoexpand" = false ]; then elif [ "$should_skip_autoexpand" = false ]; then
@ -313,7 +325,7 @@ if [[ $prep == true ]]; then
fi fi
#Make sure filesystem is ok # Make sure filesystem is ok
checkFilesystem checkFilesystem
if ! minsize=$(resize2fs -P "$loopback"); then if ! minsize=$(resize2fs -P "$loopback"); then
@ -328,7 +340,7 @@ if [[ $currentsize -eq $minsize ]]; then
exit 11 exit 11
fi fi
#Add some free space to the end of the filesystem # Add some free space to the end of the filesystem
extra_space=$(($currentsize - $minsize)) extra_space=$(($currentsize - $minsize))
logVariables $LINENO extra_space logVariables $LINENO extra_space
for space in 5000 1000 100; do for space in 5000 1000 100; do
@ -339,7 +351,7 @@ for space in 5000 1000 100; do
done done
logVariables $LINENO minsize logVariables $LINENO minsize
#Shrink filesystem # Shrink filesystem
info "Shrinking filesystem" info "Shrinking filesystem"
resize2fs -p "$loopback" $minsize resize2fs -p "$loopback" $minsize
rc=$? rc=$?
@ -353,7 +365,7 @@ if (( $rc )); then
fi fi
sleep 1 sleep 1
#Shrink partition # Shrink partition
partnewsize=$(($minsize * $blocksize)) partnewsize=$(($minsize * $blocksize))
newpartend=$(($partstart + $partnewsize)) newpartend=$(($partstart + $partnewsize))
logVariables $LINENO partnewsize newpartend logVariables $LINENO partnewsize newpartend
@ -371,7 +383,7 @@ if (( $rc )); then
exit 14 exit 14
fi fi
#Truncate the file # Truncate the file
info "Shrinking image" info "Shrinking image"
endresult=$(parted -ms "$img" unit B print free) endresult=$(parted -ms "$img" unit B print free)
rc=$? rc=$?
@ -389,13 +401,15 @@ if (( $rc )); then
exit 16 exit 16
fi fi
# handle compression # Handle the compression
if [[ -n $ziptool ]]; then if [[ -n $ziptool ]]; then
options="" options=""
envVarname="${MYNAME^^}_${ziptool^^}" # PISHRINK_GZIP or PISHRINK_XZ environment variables allow to override all options for gzip or xz envVarname="${MYNAME^^}_${ziptool^^}" # PISHRINK_GZIP or PISHRINK_XZ environment variables allow to override all options for gzip or xz
[[ $parallel == true ]] && options="${ZIP_PARALLEL_OPTIONS[$ziptool]}" [[ $parallel == true ]] && options="${ZIP_PARALLEL_OPTIONS[$ziptool]}"
[[ -v $envVarname ]] && options="${!envVarname}" # if environment variable defined use these options [[ $compression != 6 ]] && options="$options -$compression" # Update the compression value if requested (default value is 6)
[[ $verbose == true ]] && options="$options -v" # add verbose flag if requested [[ "$ziptool" == "xz" ]] && [[ $extreme == true ]] && options="$options -e" # Add extreme flag if requested for xz
[[ -v $envVarname ]] && options="${!envVarname}" # If environment variables defined use these options
[[ $verbose == true ]] && options="$options -v" # Add verbose flag if requested
if [[ $parallel == true ]]; then if [[ $parallel == true ]]; then
parallel_tool="${ZIP_PARALLEL_TOOL[$ziptool]}" parallel_tool="${ZIP_PARALLEL_TOOL[$ziptool]}"
@ -406,7 +420,7 @@ if [[ -n $ziptool ]]; then
exit 18 exit 18
fi fi
else # sequential else # Sequential
info "Using $ziptool on the shrunk image" info "Using $ziptool on the shrunk image"
if ! $ziptool ${options} "$img"; then if ! $ziptool ${options} "$img"; then
rc=$? rc=$?
@ -414,6 +428,7 @@ if [[ -n $ziptool ]]; then
exit 19 exit 19
fi fi
fi fi
img=$img.${ZIPEXTENSIONS[$ziptool]} img=$img.${ZIPEXTENSIONS[$ziptool]}
fi fi